@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
CD /D %~dp0
IF %1.==. GOTO :Usage
IF %1.==/?. GOTO :Usage

SET Image="%*"
SET Image=%Image:"=%
CALL :set_image "%Image%"

IF NOT EXIST %Image% GOTO :NOT_FOUND

SET installed=0
SET numdrives=0
SET PDrive=
CALL :check_mount %Image%
IF DEFINED PDrive (
ECHO.
ECHO Image     : %Image%
ECHO will be removed together with %PDrive%
PAUSE
vstorcontrol remove %PDrive%
) ELSE (
ECHO.
ECHO **************************************ERROR************************************
ECHO Image     : %Image%
ECHO is not currently mounted!
)
CALL :check_install
IF %numdrives%==0 vstorcontrol uninstall

GOTO :EOF

:set_image
SET Image="%~dpnx1"
GOTO :EOF


:check_mount
FOR /F "tokens=1,* delims=:" %%A IN ('vstorcontrol list -verbose') DO (
IF "%%A"=="Drive     " SET PDrive=%%B
IF /I "%%B"==" %~dpnx1" ECHO %%B = !PDrive!&GOTO :EOF
)
SET PDrive=
GOTO :EOF

:check_install
FOR /F "tokens=1,* delims=:" %%A IN ('vstorcontrol list -verbose') DO (
IF "%%A"=="Number of Drives " (
ECHO.
SET numdrives=%%B
SET installed=1
)
)
GOTO :EOF

:USAGE
CLS
ECHO.
REM vsUmount.cmd
ECHO %~nx0 -	Small batch file by jaclaz
ECHO			to Uninstall and Unmount a disk or drive image through VSS services
ECHO			Release ALPHA 0.01 13th September 2009
ECHO.
ECHO USAGE:
ECHO vsUmount [filename]
ECHO.
ECHO WHERE [filename] is the name of EITHER:
ECHO         a MOUNTED DISK (whole disk) image file with MBR and hidden sectors
ECHO or
ECHO         a MOUNTED DRIVE (partition/superfloppy) image file
ECHO.
ECHO For the joy of non-dinosaurs you can also use a PATH with spaces within
ECHO (and you don't even need to put it betweeen double quotes) ;-)
ECHO.
ECHO EXAMPLES:
ECHO vsUmount C:\myimage.img
ECHO vsUmount C:\My Stupid and abnormally long path including spaces\myimage.img 
GOTO :EOF

:NOT_FOUND
ECHO.
ECHO **************************************ERROR************************************
ECHO FILE      : %Image%
ECHO NOT FOUND!
GOTO :EOF