@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
CD /D %~dp0
IF %1.==. GOTO :Usage
IF %1.==/?. GOTO :Usage

SET Image="%*"
SET Image=%Image:"=%
CALL :set_image "%Image%"

IF NOT EXIST %Image% GOTO :NOT_FOUND

SET installed=0

CALL :check_install

IF %installed%==0 vstorcontrol install&CALL :check_install

CALL :check_mount %Image%

GOTO :EOF

:set_image
SET Image="%~dpnx1"
GOTO :EOF

:check_mount
::Check if image is already mounted
FOR /F "tokens=1,* delims=: " %%A IN ('vstorcontrol list -verbose') DO (
IF "%%A"=="Image" (
IF "%%B"=="%~1" (
ECHO.
ECHO **************************************ERROR************************************
ECHO Image     : %Image%
ECHO is ALREADY mounted!
PAUSE
GOTO:EOF
)
)
)
ECHO.
ECHO Image     : %Image%
ECHO will be installed on VSDrive %numdrives%
ECHO.
PAUSE
vstorcontrol create fixeddisk -image %Image%

GOTO :EOF

:check_install
FOR /F "tokens=1,* delims=:" %%A IN ('vstorcontrol list -verbose') DO (
IF "%%A"=="----------" (ECHO %%A) ELSE (ECHO %%A:%%B)
REM IF %%A==Virtual ECHO %%A %%B %%C %%D&ECHO.
IF "%%A"=="Number of Drives " (
ECHO.
SET numdrives=%%B
SET installed=1
)
)
GOTO :EOF

:USAGE
CLS
ECHO.
REM vsmount.cmd
ECHO %~nx0 -	Small batch file by jaclaz
ECHO			to install and mount a disk or drive image through VSS services
ECHO			Release ALPHA 0.01 13th September 2009
ECHO.
ECHO USAGE:
ECHO	vsmount [filename]
ECHO.
ECHO WHERE [filename] is the name of EITHER:
ECHO         a DISK (whole disk) image file with MBR and hidden sectors
ECHO or
ECHO         a DRIVE (partition/superfloppy) image file
ECHO.
ECHO For the joy of non-dinosaurs you can also use a PATH with spaces within
ECHO (and you don't even need to put it betweeen double quotes) ;-)
ECHO.
ECHO EXAMPLES:
ECHO vsmount C:\myimage.img
ECHO vsmount C:\My Stupid and abnormally long path including spaces\my image.img
GOTO :EOF

:NOT_FOUND
ECHO.
ECHO **************************************ERROR************************************
ECHO FILE      : %Image%
ECHO NOT FOUND!
GOTO :EOF
